/*
Program: folder-info.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: Hj覡ܫwؿҦɮ׻PɮקT
Note: {ϥdirent.hAӼYɩwqؿcƫAAӼYɦ 
	C:\Program Files (x86)\Dev-Cpp\MinGW64\x86_64-w64-mingw32\include 
*/
 
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>
#include <dirent.h> 

#define MaxSize 256

int chopPos(char *dirPath)
{
	int i, count, len = strlen(dirPath);
	
	if (dirPath[len-1] != '\\') {
		dirPath[len] = '\\';
		dirPath[len+1] = '\0';
	}
	
	for (i = len-1, count = 0; i > 0 && count < 2; i--)
		if (dirPath[i]=='\\') count++;
	
	return i+2;
}

void showDirectory(char *folderPath, int level) 
{
	DIR    *dpdf;
	struct dirent *epdf;
	char   fileName[2*MaxSize], nextLevelDir[128][768], *pstr, indent[2*MaxSize]={0};
	long   fileSize, fileCount, i, dirCount = 0;
	FILE   *fp;
	
	if ((dpdf=opendir(folderPath)) == NULL) { /* }ҥؿƵc */ 
		printf("ؿ%ssb!\n",folderPath);
		return;
	}

	pstr = folderPath+chopPos(folderPath);
	if (level==0) {
		printf("%s\n",pstr);
		sprintf(indent,"%s%s",indent,"|   ");
	}
	else {
		for (i = 0; i < level-1; i++) 
			sprintf(indent,"%s%s",indent,"|   ");
		printf("%s+---%s\n",indent,pstr); 
		sprintf(indent,"%s%s",indent,"|   |   ");
	}
	
	while (epdf = readdir(dpdf)) { /* ŪɮשҦbؿAundpdfҫešAYNۦɮצsbA]iJjBz */ 
		if (strcmp(epdf->d_name,".")==0 || strcmp(epdf->d_name,"..")==0) continue; /* ưؿ . P .. (UؿPW@hؿ) */
		sprintf(fileName,"%s%s",folderPath,epdf->d_name); // |+ɦW
		if ((fp=fopen(fileName,"rb")) == NULL) { // }ɮסA}ɼҦ"rDrqY" 
			sprintf(nextLevelDir[dirCount++],"%s\\",fileName);
		}
		else {
			fclose(fp);	
			printf("%s%s\n",indent,epdf->d_name);
			fileCount++;
		}
	}	
	closedir(dpdf); /* ؿƵc */ 
	if (fileCount > 0) {
		if (level==0)
			printf("%s(W%dɮ)\n%s\n",indent,fileCount,indent);
		else {
			printf("%s(W%dɮ)\n",indent,fileCount);
			for (i = 0; i < strlen(indent)-4; i++) putchar(indent[i]);
			printf("\n");
		}
	}
	
	if (dirCount > 0) {
		for (i = 0; i < dirCount; i++)
			showDirectory(nextLevelDir[i],level+1);
	}
	
	return;
}

int main()
{
	char directoryPath[MaxSize];
	
	printf("\nJؿ| ==> ");
	scanf("%255[^\n]%*c",directoryPath,0); 
	printf("ɮק%sTpU\n",directoryPath);
	showDirectory(directoryPath,0);
	
	return 0;
}
